



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ArrayList 源码（基于Java1.8）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ArrayList 源码（基于Java1.8）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 10:21:38 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>ArrayList 源码</p>
<p>ArrayList 基于数组实现，也就是类对变量 Object[]系列操作，封装为常用的add，remove，indexOf, contains本质是通过 size 计数器对数组进行系列的操作实现</p>
<p>add 方法和 toArray 也是借助 Arrays 工具类完成</p>
<p>还有很有意思的地方就是add的扩容方法 ensureCapacityInternal() 就会增加50%容量，</p>
<p>因为底层数组是不可变的，所以add实际上是通过Arrays工具再拷贝扩容后长度的数组，然后覆盖当前数组</p>
<p>预设集合长度是最优的操作，今天看源码才明白原理，ArrayList默认构造器为内部数组定义的长度为10，当list超出指定集合的时候，ArrayList会操作自动扩容，</p>
<p>扩容的方法是使用Arrays.copyOf方法重新构造新的数组，然后将旧数组的数据全部拷贝到新的数组里面，重新生成，再拷贝数组，消耗是巨大的，这也导致了 ArrayList 天生的缺点，插入删除元素慢</p>
<p><img></p>
<p>源码中可以看到，ArrayList继承抽象类AbstractList，实现List接口，RandomAccess, Cloneable, Serializable等接口主要用于标识，并没有很大作用</p>
<p>DEFAULT_CAPACITY = 10 是集合的默认初始化长度，我们常用new ArrayList&lt;&gt;()构造，其实就是创建一个长度为10的Object[]数组</p>
<p>size 为计数器，记录当前数组的长度</p>
<p><img></p>
<p>构造器的代码中，看下最常用的两个构造器，带参数initialCapacity的构造器，直接就让变量创建对应长度的数组，如果initialCapacity == 0 就直接赋值为空数组 Object[] elementData = {};</p>
<p>下面无参构造器，就直接初始化容量为10的空列表</p>
<p><img></p>
<p>上面的自动扩展数组容量的方法，每次添加元素都会调用该方法，确保集合的长度足够用，上面代码中最有趣的是2行</p>
<p>newCapacity = oldCapacity + (oldCapacity &gt;&gt; 1)， 既每次扩大容量为当前容量的50%，这里的扩容是固定的，和HashMap有负载因子不同</p>
<p>然后调用 Arrays.copyOf() 将旧数组内容和新长度作为参数，创建新的Object[]数组，并且将原数组的元素，拷贝到新的数组里面</p>
<p>因为数组长度是不可变的，所以这里的做法是，创建新的数组，再拷贝元素，这里也是ArrayList性能最低的地方</p>
<p><img></p>
<p><img></p>
<p><img></p>
<p><img></p>
<p>常用的size，isEmpty，contains，indexOf 也只是对Object[] 进行系列的循环判断操作</p>
<p><img></p>
<p>get方法，也是指通过下标，从Object[]数组中获取对象，然后转型 Object -&gt; E</p>
<p><img></p>
<p>add末尾添加元素方法步骤，先判断容量是否够用，然后在数组末尾elementData[size++] == e，加入新的元素，size为数组长度</p>
<p><img></p>
<p>remove 方法，也是通过循环equals匹配，找到下标，然后通过下标删除，—size，减去计数器长度，并没有实际减少数组长度</p>
<p>clear方法也相同，把数组的值都设为null，然后 size = 0;</p>
<p>总结：</p>
<p>通过以上对ArrayList关键部分源码分析，通晓ArrayList原理，我们可以得出结论：</p>
<ol><li>arrayList 底层来自数组，通过下标随机访问元素，速度非常快，但是插入和删除，要频繁的移动数组元素，改变数组长度，效率比较低</li>
<li>arrayList 主要性能问题在于当数组元素达到容量上限，扩容的成本很大，所以能够预先知道元素，然后使用 new ArrayList(int initialCapacity) 手动设置容量是最好的</li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8konjjq.html">iOS 学习 - 25 ImageIO 播放 GIF</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7ekek9.html">Android6&period;0动态申请权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxemke8.html">Android中的数据保存</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4dvlnq.html">I&sol;O流&mdash;&mdash;其他流</a>
		</li>
						<li><a href="https://www.batexi.com/a/495z0nm9.html">cookie session URL重写 与考试</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjn3w79.html">iBatis面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12gn39.html">CCLabelTTF、CCLabelAtlas和CCLabelBMFont的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo175xq.html">python语言学习2&mdash;&mdash;安装python</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpr1mzq.html">用C&num;操作IIS创建虚拟目录和网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyll2z9.html">UED团队规范设计参考及建议</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk00lj8.html">quill富文本编辑器 API</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy5o3xq.html">CentOS 7最小安装之后应该尽快做好的几件事情</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy340mq.html">spark - Locality Level</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll0k06q.html">cvLogPolar函数详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2lopy9.html">IIS下使用 HTTP&sol;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1wz269.html">Spring源码分析（八）AbstractBeanDefinition属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjvepp8.html">&lbrack;Backbone&rsqb;8&period; Level 7&colon; Router and history</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p563nq.html">JavaSE（八）集合之List</a>
		</li>
						<li><a href="https://www.batexi.com/a/953oz4v8.html">jquery-validation验证插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndveyg8.html">参数化查询为什么能够防止SQL注入 &lpar;转&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ey3kwx9.html">我的Spring学习记录（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jgz0o8.html">BackTrack 5无线网卡混杂模式设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1jljxq.html">SVG轨迹回放实践</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljw46k9.html">Nginx学习&mdash;&mdash;Nginx基本配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpkyp69.html">（译）通过 HTML、JS 和 Electron 创建你的第一个桌面应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjn16z8.html">Python多线程练习（threading）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z7eej9.html">sql server 2000的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoeg41q.html">Feature Scaling深入理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpr0v7q.html">百度SMS SDK for &period;Net</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mernlpq.html">关于TileBrush中Viewbox，Viewport以及Stretch，AlignmentX&sol;Y的详细研究</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
